package cn.iocoder.byzs.module.ai.service.tts;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.byzs.framework.common.pojo.PageResult;
import cn.iocoder.byzs.framework.common.util.object.BeanUtils;
import cn.iocoder.byzs.module.ai.controller.admin.tts.vo.AiTtsPageReqVO;
import cn.iocoder.byzs.module.ai.controller.admin.tts.vo.AiTtsSaveReqVO;
import cn.iocoder.byzs.module.ai.dal.dataobject.tts.AiTtsDO;
import cn.iocoder.byzs.module.ai.dal.mysql.tts.AiTtsMapper;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import java.util.List;

import static cn.iocoder.byzs.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.byzs.module.ai.enums.ErrorCodeConstants.TTS_NOT_EXISTS;

/**
 * AI TTS文转音 Service 实现类
 *
 * @author lyb
 */
@Service
@Validated
public class AiTtsServiceImpl implements AiTtsService {

    @Resource
    private AiTtsMapper ttsMapper;

    @Override
    public Long createTts(AiTtsSaveReqVO createReqVO) {
        // 插入
        AiTtsDO tts = BeanUtils.toBean(createReqVO, AiTtsDO.class);
        ttsMapper.insert(tts);
        // 返回
        return tts.getId();
    }

    @Override
    public void updateTts(AiTtsSaveReqVO updateReqVO) {
        // 校验存在
        validateTtsExists(updateReqVO.getId());
        // 更新
        AiTtsDO updateObj = BeanUtils.toBean(updateReqVO, AiTtsDO.class);
        ttsMapper.updateById(updateObj);
    }

    @Override
    public void deleteTts(Long id) {
        // 校验存在
        validateTtsExists(id);
        // 删除
        ttsMapper.deleteById(id);
    }

    @Override
        public void deleteTtsListByIds(List<Long> ids) {
        // 校验存在
        validateTtsExists(ids);
        // 删除
        ttsMapper.deleteByIds(ids);
        }

    private void validateTtsExists(List<Long> ids) {
        List<AiTtsDO> list = ttsMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(TTS_NOT_EXISTS);
        }
    }

    private void validateTtsExists(Long id) {
        if (ttsMapper.selectById(id) == null) {
            throw exception(TTS_NOT_EXISTS);
        }
    }

    @Override
    public AiTtsDO getTts(Long id) {
        return ttsMapper.selectById(id);
    }

    @Override
    public PageResult<AiTtsDO> getTtsPage(AiTtsPageReqVO pageReqVO) {
        return ttsMapper.selectPage(pageReqVO);
    }

    @Override
    public List<AiTtsDO> getTtsSimpleListByStatus(Integer status) {
        return ttsMapper.getTtsSimpleListByStatus(status);
    }

}